stages:
  - check
  - build
  - release

variables:
  IMAGE_NAME: $CI_PROJECT_PATH

.with_docker:
  image: docker:latest
  services:
    - docker:dind
  before_script: |
    echo $DOCKER_PASSWORD | docker login -u $DOCKER_USER --password-stdin
    docker pull $IMAGE_NAME || true

enable_merge:
  stage: check
  rules:
    - if: $CI_MERGE_REQUEST_ID
  script: echo true

build:
  extends: .with_docker
  stage: build
  rules:
    - if: $CI_MERGE_REQUEST_ID || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - 'Dockerfile'
    - if: $CI_COMMIT_TAG
      when: never
  script: |
    docker build --cache-from $IMAGE_NAME -t $IMAGE_NAME .
    if [ "${CI_COMMIT_BRANCH}" == "${CI_DEFAULT_BRANCH}" ]; then
      docker push $IMAGE_NAME
    fi

release:
  extends: .with_docker
  stage: release
  rules:
    - if: $CI_COMMIT_TAG
  variables:
    RELEASE_TAG: '${IMAGE_NAME}:${CI_COMMIT_TAG}'
  script: |
    docker build --cache-from $IMAGE_NAME --build-arg VERSION=${CI_COMMIT_TAG} -t $IMAGE_NAME .
    docker push $IMAGE_NAME
    docker tag $IMAGE_NAME $RELEASE_TAG
    docker push $RELEASE_TAG
